# -*- coding: utf-8 -*-
#Autor: João Victor Fabri
import numpy as np
import matplotlib.pylab as mplt


y=np.array([
        
        10, 20, 25, 30, 35, 40, 45, 50, 55
        
        ],dtype=float)  #Vetor com as potencias do motor em que foram feitos os testes

x=np.array([
        
        3, 3.6, 7.4, 9.5, 12, 13.3, 15.7, 21.4, 22.7

        ],dtype=float)  #Vetor com o alcance obtido utilizando a potencia correspondente

n=3
A=np.zeros([n+1,n+1],dtype=float)
b=np.zeros(n+1,dtype=float)
for i in range(n+1):
    for j in range(n+1):
        A[i,j]=np.sum(x**(i+j))      #realiza os calculos do sistema de equaçoes e aloca os resultados na matriz  
    b[i]=np.sum(y*x**(i))            #cria o vetor resultado   
coef=np.linalg.solve(A,b)            #calcula o resultado x da equação matricial A.x=b              
print (coef) 
                          #mostra no console os resultados dos coeficiente a serem utilizados no programa
def res(z,coef):                     
    s=0.
    for i in range(len(coef)):       #calcula o valor do polinomio regressor para um valor z 
        s+=coef[i]*(z**i)
    return s
    
mplt.plot(x,y,'r.')
X=np.linspace(0,45,1000)             #monta o grafico da funçao regressora    
Y=np.copy(X)
for i in range(len(X)):
    Y[i]=res(X[i],coef)
mplt.plot(X,Y,'g-')
mplt.plot(9,res(9,coef),'bo')
mplt.show()

print (res(9,coef))
